package net.pricefx.domain;

import com.fasterxml.jackson.annotation.JsonIgnore;


public abstract class TimedObjectWithStatus extends TimedObject {


	/* Note: Statuses should be in order of "activity" */
	public enum TimedObjectStatus {
		ACTIVE, SIMULATIONONLY, INACTIVE 
	}
	
	private TimedObjectStatus status;
	
	protected String simulationSet;
	
	
	public TimedObjectWithStatus() {
		super();
		status = TimedObjectStatus.INACTIVE;
	}

	public TimedObjectStatus getStatus() {
		return status == null ? TimedObjectStatus.ACTIVE : status;
	}

	public void setStatus(TimedObjectStatus status) {

		if(status == null) {
			this.status = TimedObjectStatus.ACTIVE;
			this.simulationSet = null;
			return;
		}
		
		switch(status) {
			case ACTIVE:
				this.simulationSet = null;
				this.status = TimedObjectStatus.ACTIVE;
				break;
			case INACTIVE:
				this.simulationSet = null;
				this.status = TimedObjectStatus.INACTIVE;
				break;
			case SIMULATIONONLY:
				this.status = TimedObjectStatus.SIMULATIONONLY;				
				break;				
		}
	}

	public String getSimulationSet() {
		return simulationSet;
	}

	public void setSimulationSet(String simulationSet) {
		if(simulationSet != null)
			this.status = TimedObjectStatus.SIMULATIONONLY;	
		
		this.simulationSet = simulationSet;
	}
	
	@JsonIgnore
	public boolean isActive() {
		if(status == null || TimedObjectStatus.ACTIVE.equals(status))
			return true;
		else
			return false;
	}
	
	public String[] getSignificantFields() {
		return new String[] { "uniqueName","validAfter","simulationSet" };
	}	

}
